*:*********************************************************************
*:
*:        Program: PRB_BLET.PRG
*:
*:         System: Major Function Library
*:         Author: Phil Barnett
*:      Copyright (c) 1991, Phil Barnett
*:  Last modified: 03/16/91     20:10
*:
*:  Procs & Fncts: BIG_LET()
*:
*:      Documented 03/16/91 at 20:10                SNAP!  version 4.02
*:*********************************************************************
*!*********************************************************************
*!
*!       Function: BIG_LET()
*!
*!*********************************************************************
FUNCTION big_let

parameters  _top,_left,_display

*  _top     = _top line of pictures
*  _left    = _left end of pictures
*  _display = _display to display (can be string or numeric)

*  characters that can be displayed are: ABCDEFGHIJKLMNOPQRSTUVQXYZ
*                                        0123456789.-+*/:"'!%?$
*  other characters will be displayed as a space
*  lower case is automatically converted to upper case

*    if the _left parameter is passed as anything but a character, big_let will
*    attempt to center the large characters in the display

*    Example:
 
*    big_let(10,.f.,ampm(time()))   && Centers the clock on the screen

*    or

*    big_let(10,1,ampm(time()))     && places the clock on column 1

*    The case statements improve the overall speed of the routine

PRIVATE x,this_part,_strlen,_result

_display = UPPER(_display)

_strlen = len(_display)

IF TYPE('_left') <> 'N'
  _result = 0
  FOR x = 1 TO _strlen
    this_part = SUBSTR(_display,x,1)
    _result = _result + IIF(this_part $ [.:'!],3,7)
  NEXT
  _left = IIF(82-_result<0,0,(82 - _result) / 2)
ENDIF

FOR x = 1 TO _strlen
  this_part = SUBSTR(_display,x,1)
  DO CASE
  CASE this_part $ 'ABCDEFGHJKLM'
    DO CASE
    CASE this_part = 'A'
      line1 = ''
      line2 = '   '
      line3 = ''
      line4 = '   '
      line5 = '   '
    CASE this_part = 'B'
      line1 = ' '
      line2 = '   '
      line3 = ''
      line4 = '   '
      line5 = ''
    CASE this_part = 'C'
      line1 = ''
      line2 = '    '
      line3 = '    '
      line4 = '    '
      line5 = ''
    CASE this_part = 'D'
      line1 = ' '
      line2 = '   '
      line3 = '   '
      line4 = '   '
      line5 = ''
    CASE this_part = 'E'
      line1 = ''
      line2 = '    '
      line3 = ' '
      line4 = '    '
      line5 = ''
    CASE this_part = 'F'
      line1 = ''
      line2 = '    '
      line3 = ' '
      line4 = '    '
      line5 = '    '
    CASE this_part = 'G'
      line1 = ''
      line2 = '    '
      line3 = '  '
      line4 = '   '
      line5 = ''
    CASE this_part = 'H'
      line1 = '   '
      line2 = '   '
      line3 = ''
      line4 = '   '
      line5 = '   '
    CASE this_part = 'J'
      line1 = '    '
      line2 = '    '
      line3 = '    '
      line4 = '    '
      line5 = ''
    CASE this_part = 'K'
      line1 = '   '
      line2 = '  '
      line3 = '  '
      line4 = '  '
      line5 = '   '
    CASE this_part = 'L'
      line1 = '    '
      line2 = '    '
      line3 = '    '
      line4 = '    '
      line5 = ''
    CASE this_part = 'M'
      line1 = ''
      line2 = '  '
      line3 = '  '
      line4 = '  '
      line5 = '  '
    ENDCASE
    add_on = 7
  CASE this_part $ 'NOPQRSTUVWXYZ'
    DO CASE
    CASE this_part = 'N'
      line1 = '   '
      line2 = '  '
      line3 = '  '
      line4 = ' '
      line5 = '  '
    CASE this_part = 'O'
      line1 = ''
      line2 = '   '
      line3 = '   '
      line4 = '   '
      line5 = ''
    CASE this_part = 'P'
      line1 = ''
      line2 = '   '
      line3 = ''
      line4 = '    '
      line5 = '    '
    CASE this_part = 'Q'
      line1 = ''
      line2 = '   '
      line3 = '   '
      line4 = '  '
      line5 = ''
    CASE this_part = 'R'
      line1 = ''
      line2 = '   '
      line3 = ''
      line4 = '  '
      line5 = '   '
    CASE this_part = 'S'
      line1 = ''
      line2 = '    '
      line3 = ''
      line4 = '    '
      line5 = ''
    CASE this_part = 'T'
      line1 = ''
      line2 = '    '
      line3 = '    '
      line4 = '    '
      line5 = '    '
    CASE this_part = 'U'
      line1 = '   '
      line2 = '   '
      line3 = '   '
      line4 = '   '
      line5 = ''
    CASE this_part = 'V'
      line1 = '   '
      line2 = '   '
      line3 = '   '
      line4 = '   '
      line5 = '  '
    CASE this_part = 'W'
      line1 = '  '
      line2 = '  '
      line3 = '  '
      line4 = '  '
      line5 = ''
    CASE this_part = 'X'
      line1 = '   '
      line2 = ' '
      line3 = '  '
      line4 = '   '
      line5 = '   '
    CASE this_part = 'Y'
      line1 = '   '
      line2 = '   '
      line3 = ''
      line4 = '    '
      line5 = '    '
    CASE this_part = 'Z'
      line1 = ''
      line2 = '   '
      line3 = '   '
      line4 = '    '
      line5 = ''
    ENDCASE
    add_on = 7
  case this_part $ '01234I'
    DO CASE
    CASE this_part = '0'
      line1 = ''
      line2 = '   '
      line3 = '   '
      line4 = '   '
      line5 = ''
    CASE this_part = '1' .OR. this_part = 'I'
      line1 = '    '
      line2 = '    '
      line3 = '    '
      line4 = '    '
      line5 = '    '
    CASE this_part = '2'
      line1 = ''
      line2 = '    '
      line3 = ''
      line4 = '    '
      line5 = ''
    CASE this_part = '3'
      line1 = ''
      line2 = '    '
      line3 = ''
      line4 = '    '
      line5 = ''
    CASE this_part = '4'
      line1 = '   '
      line2 = '   '
      line3 = ''
      line4 = '    '
      line5 = '    '
    endcase
    add_on = 7
  case this_part $ '56789'
    do case
    CASE this_part = '5'
      line1 = ''
      line2 = '    '
      line3 = ''
      line4 = '    '
      line5 = ''
    CASE this_part = '6'
      line1 = '    '
      line2 = '    '
      line3 = ''
      line4 = '   '
      line5 = ''
    CASE this_part = '7'
      line1 = ''
      line2 = '    '
      line3 = '    '
      line4 = '    '
      line5 = '    '
    CASE this_part = '8'
      line1 = ''
      line2 = '   '
      line3 = ''
      line4 = '   '
      line5 = ''
    CASE this_part = '9'
      line1 = ''
      line2 = '   '
      line3 = ''
      line4 = '    '
      line5 = '    '
    endcase
    add_on = 7
  otherwise
    do case
    CASE this_part = '.'
      line1 = ''
      line2 = ''
      line3 = ''
      line4 = ''
      line5 = ''
    CASE this_part = '-'
      line1 = ''
      line2 = ''
      line3 = ''
      line4 = ''
      line5 = ''
    CASE this_part = '+'
      line1 = ''
      line2 = '    '
      line3 = ''
      line4 = '    '
      line5 = ''
    CASE this_part = '*'
      line1 = ''
      line2 = '   '
      line3 = '  '
      line4 = '   '
      line5 = ''
    CASE this_part = ':'
      line1 = ''
      line2 = ''
      line3 = ''
      line4 = ''
      line5 = ''
    CASE this_part = '"'
      line1 = '   '
      line2 = '   '
      line3 = ''
      line4 = ''
      line5 = ''
    CASE this_part = "'"
      line1 = ''
      line2 = ''
      line3 = ''
      line4 = ''
      line5 = ''
    CASE this_part = '!'
      line1 = ''
      line2 = ''
      line3 = ''
      line4 = ''
      line5 = ''
    CASE this_part = '%'
      line1 = '   '
      line2 = '  '
      line3 = '   '
      line4 = '    '
      line5 = '   '
    CASE this_part = '/'
      line1 = '    '
      line2 = '   '
      line3 = '   '
      line4 = '    '
      line5 = '    '
    CASE this_part = '?'
      line1 = ''
      line2 = '   '
      line3 = '  '
      line4 = '    '
      line5 = '    '
    CASE this_part = '$'
      line1 = ''
      line2 = '   '
      line3 = ''
      line4 = '   '
      line5 = ''
    OTHERWISE
      line1 = '     '
      line2 = '     '
      line3 = '     '
      line4 = '     '
      line5 = '     '
    ENDCASE
    add_on = IIF(this_part $ [.:'!],3,7)
  ENDCASE
  
  @ _top  ,_left SAY line1
  @ _top+1,_left SAY line2
  @ _top+2,_left SAY line3
  @ _top+3,_left SAY line4
  @ _top+4,_left SAY line5
  
  _left = _left + add_on
NEXT

RETURN .T.
*: EOF: PRB_BNUM.PRG
